using System;
using System.Drawing;

namespace NeuroX
{
	/// <summary>
	/// //a Neuron which generates constant signal
	/// </summary>
	public class NeuronConstant : NeuroX.Neuron
	{
		public NeuronConstant(Point p)
		{
			point = p;
			output = 1;
			InitializeNeuron();
			myPen = new Pen(Color.Green, 2);
			drawBrush = new SolidBrush(Color.Green);

		}
		public override void randomParam(Random r)
		{

		}

		/// <summary>
		/// // constant signal
		/// </summary>

		public override void standardParam()
		{

		}
		public override double CalculateOutput()
		{
			return 1;
		}
		public override void reset()
		{
			output = 1;
		}
		public override void reset(Random r)
		{
			output = 1;
		}

		public override void Paint(System.Drawing.Graphics g)
		{
			
			base.Paint(g);
			g.DrawString("C",myFont,drawBrush,new Point(point.X,point.Y-15));
		}
	
		public override object Clone()
		{
			// TODO:  Add NeuronConstant.Clone implementation
			NeuronConstant nc = new NeuronConstant(point);
			Clone(nc);
			return null;
		}
	}
}
