using System;
using System.Drawing;

using System.Windows.Forms;


namespace NeuroX
{
	/// <summary>
	/// 
	/// </summary>
	public class NeuronDifferentiate : NeuroX.Neuron
	{
		public NeuronDifferentiate(Point point,double prevInput, double output, bool bOptimize)
		{
			this.bOptimize = bOptimize;
			this.point = new Point(point.X,point.Y);
			this.prevInput = prevInput;
			this.output = output;
			InitializeNeuron();
			myPen = new Pen(Color.Red, 2);
			drawBrush = new SolidBrush(Color.Red);
		}
		public double prevInput;
		public override void randomParam(Random r)
		{
			
		}
		
		public override double CalculateOutput()
		{
			output = input - prevInput;
			prevInput = input;
			return output;
		}
		public override void reset()
		{
			prevInput = 0;
		}
		public override void reset(Random r)
		{
			prevInput = -1 + r.NextDouble()*(2);
		}
		public override void standardParam()
		{

		}

		public override void Paint(System.Drawing.Graphics g)
		{
			base.Paint(g);
			g.DrawString("D",myFont,drawBrush,new Point(point.X,point.Y-15));
		}

	
		public override object Clone()
		{
			NeuronDifferentiate nd = new NeuronDifferentiate(point,prevInput,output,bOptimize);	
			Clone(nd);
			return nd;
		}
	}
}
